#! /usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on January 25, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#

BEGIN {
if($0 !~ /^install\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}

$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'library.pl';
use Socket;


&parse_form;

if($FORM{'action'} eq "") {
	&admin_header;
	$this_dir =~ s/\\/\//g;
	print qq!
	<H3>Post Office Installation</H3>
	This program will install and configure Post Office for you.
	Please follow the directions on each of the pages to install Post Office.<P>
	
	<H3>Step 1</H3>
	<FORM ACTION="install.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
	<OL TYPE=1>
	<LI> The first step in installing Post Office is to create a directory on your
	server where Post Office can store its files.  You should use your FTP
	program or telnet program to create a directory on your server.</LI><P>
	<LI> Change the permissions on the directory you just created to 777 or
	read, write, and execute to all.  You can do so by right clicking on the
	directory in your FTP program and choosing <I>CHMOD</I> or <I>Change Permissions</I>.
	<B><FONT COLOR="BB0000">If you are on a windows server you <U>do not</U> need to change the permissions</B></FONT></LI><P>
	<LI> Enter the absolute path to the directory you just created in the box below and
	then press continue<BR>
	<INPUT TYPE="TEXT" NAME="base_dir" VALUE="$ENV{'DOCUMENT_ROOT'}/your/directory" SIZE=40><P>
	<B>Examples:</B><BR>
	/usr/home/myusername/www/postoffice<BR>
	c:/home/www/myusername/postoffice<BR>
	</LI><P>
	
	<LI> Enter the absolute path to the directory where you uploaded the CGI files.<BR>
	<INPUT TYPE="TEXT" NAME="this_dir" SIZE=40 VALUE="$this_dir">
	</LI><P>
	
	</OL>
	<INPUT TYPE="SUBMIT" VALUE="Continue">
	</FORM>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "step2") {
	
	$FORM{'base_dir'} =~ s/\\/\//g;
	$FORM{'this_dir'} =~ s/\\/\//g;
	
	if($FORM{'this_dir'} =~ /\/$/) {
		chop($FORM{'this_dir'});
	}
	
	if($FORM{'base_dir'} =~ /\/$/) {
		chop($FORM{'base_dir'});
	}
	
	if(! -e "$FORM{'this_dir'}/config.pl") {
		
		if(! -e "$FORM{'this_dir'}") {
			&admin_header;
			print qq!
			<FORM ACTION="install.pl" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
			<H3>Post Office Error</H3>
			Post Office was unable to find the directory you specified as the path to where
			you uploaded the cgi files.  Make sure that you are entering the absolute path
			to where the directory is located and not a web address location.  Please
			correct your path below and then press continue.<P>
			<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
			<INPUT TYPE="TEXT" NAME="this_dir" SIZE=40 VALUE="$FORM{'this_dir'}">
			<P>
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM>
			!;
			&admin_footer;
		}
		else {
			&admin_header;
			print qq!
			<FORM ACTION="install.pl" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
			<H3>Post Office Error</H3>
			Post Office was able to find the directory you specified as the directory
			where you uploaded the CGI files.  However, Post Office was unable to find
			the config.pl that is suppose to be located inside the directory.  Please
			make sure that you have uploaded all the CGI scripts to the directory and
			make sure that you have specified to correct directory.  Press continue
			when you are ready to try again.<P>
			
			<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
			<INPUT TYPE="TEXT" NAME="this_dir" SIZE=40 VALUE="$FORM{'this_dir'}">
			<P>
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM>
			!;
			&admin_footer;
			
		}
		exit;
	}
	
	# If we find the directory lets try creating some files.
	if(-e "$FORM{'base_dir'}") {
		unlink("$FORM{'base_dir'}/test.txt");
		open(TEST,">$FORM{'base_dir'}/test.txt");
		print TEST "Everything is ok!";
		close(TEST);
		
		if(-e "$FORM{'base_dir'}/test.txt") {
			unlink("$FORM{'base_dir'}/test.txt") || &admin_error("Post Office does not have permission to delete files from the directory you specified.");
			&admin_header;
			print qq!
			<FORM ACTION="install.pl" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="step3">
			<H3>Step 2</H3>
			Now we must configure how we would like to send our email.  Post Office
			currently supports two mail options.  We support both sending email
			by using sendmail and by your SMTP server.  In order to use sendmail
			you must have sendmail or a sendmail emulator installed on your server.
			(Almost all Unix servers have sendmail installed)  In order to use the
			SMTP option, you must have access to a SMTP server.  Most Windows users
			must choose the SMTP option.<P>
			<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
			<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
			Please choose a mailing option:<BR>
			<SELECT NAME="mail_type">
			<OPTION VALUE="">-- Choose One --</OPTION>
			<OPTION VALUE="0">Sendmail</OPTION>
			<OPTION VALUE="1">SMTP server</OPTION>
			</SELECT><P>
			
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM>
			!;
			&admin_footer;
			# The base directory is set correctly! =)
		}
		else {
			&admin_header;
			print qq!
			<FORM ACTION="install.pl" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
			<H3>Error: Access to the directory denied</H3>
			The path you entered was found.  However, Post Office
			was unable to create files in the directory.  Make sure
			that you have set the path to the correct directory and that
			you have changed the permissions to 777 if you are on a Unix server.
			After you have double checked the permissions
			and the path press continue to try again.<P>
			<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
			<INPUT TYPE="TEXT" NAME="base_dir" VALUE="$FORM{'base_dir'}" SIZE=40><P>
			
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM><P>
			
			If you are still unable to get past this step and you feel that you
			have done everything correctly, use our
			<A HREF="http://www.web-consult.com/scripts/">web forum</A> for technical support.
			<P>
			!;
			&admin_footer;
		}
	}
	
	# Give them an error and tell them to try again.
	else {
		&admin_header;
		print qq!
		<FORM ACTION="install.pl" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
		<H3>That path you entered was not found</H3>
		The path you entered to your directory was not found.  Please double check
		that you are entering the correct path.  The path is the actual location of
		the directory on the server, not the web address location.  Please try again
		by entering the path to your directory in the box below.<P>
		<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
		<INPUT TYPE="TEXT" SIZE=40 NAME="base_dir"><P>
		<B>Hint, The <U>path</U> to this script is:</B> $0<BR>
		Warning: Sometimes this is wrong, it depends on how your server is configured.<P>
		
		If you are stuck and cannot figure out the path to the directory you just
		created, you can try asking your server administrator or web hosting
		technical support.<P>
		
		<INPUT TYPE="SUBMIT" VALUE="Continue">
		</FORM><P>
		
		!;
		&admin_footer;
	}
}

elsif($FORM{'action'} eq "step3") {
	if($FORM{'mail_type'} eq "") {
		&admin_error("You did not choose a mailing option.  Please click <A HREF=\"javascript:history.back()\">here</A> to try again.");	
	}
	elsif($FORM{'mail_type'} == 0) {
		# Sendmail
		&admin_header;
		
		$mailprog = `which sendmail` || `whereis sendmail` || "/usr/bin/sendmail";
		
		print qq!
		<H3>Step 3</H3>
		<FORM ACTION="install.pl" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="step4">
		<INPUT TYPE="HIDDEN" NAME="mail_type" VALUE="$FORM{'mail_type'}">
		<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
		<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
		
		Please specify the location of your sendmail program.<P>
		<INPUT TYPE="TEXT" NAME="mailprog" SIZE=30 VALUE="$mailprog"><P>
		
		<B>The most common locations on Unix servers are:</B.<BR>
		/usr/bin/sendmail<BR>
		/usr/sbin/sendmail<BR>
		/usr/local/bin/sendmail<P>
		
		The following information will be used as the default administrator information
		for your mailing lists.<P>
		
		<B>From</B> Who is the email message from?<BR>
		<INPUT TYPE="TEXT" SIZE=25 NAME="admin_name"><P>
		
		<B>Reply-To</B> The reply-to email address of your messages<BR>
		<INPUT TYPE="TEXT" SIZE=25 NAME="admin_email_address"><P>
		
		<FONT COLOR="BB0000"><B>As a test, an email message will also be sent to the above email
		address to make sure everything is working properly.</B></FONT><P>
		
		<INPUT TYPE="SUBMIT" VALUE="Continue">
		</FORM><P>
		
		!;
		&admin_footer;	
	}
	else {
		# SMTP server
		&admin_header;
		print qq!
		<H3>Step 3</H3>
		<FORM ACTION="install.pl" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="step4">
		<INPUT TYPE="HIDDEN" NAME="mail_type" VALUE="$FORM{'mail_type'}">
		<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
		Please specify the hostname of your SMTP mail server.<BR>
		<INPUT TYPE="TEXT" SIZE=25 NAME="smtp_server" VALUE="mail.something.com"><P>
		<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
		Please specify the port number. (Almost all SMTP servers use port 25)<BR>
		<INPUT TYPE="TEXT" SIZE=5 NAME="smtp_port" VALUE="25"><P>
		!;
		
		#Some SMTP servers do not allow you to send mail until you have first logged in
		#to your POP3 email account.  If this is true in your case, please enter your POP3
		#account username and password.  <B>It is recommended that you leave this blank
		#unless you get an error when you press continue</B><P>
		
		#Username: <INPUT TYPE="TEXT" SIZE=25 NAME="pop_user"><BR>
		#Password: <INPUT TYPE="TEXT" SIZE=25 NAME="pop_password"><P>
		
		print qq!	
		The following information will be used as the default information
		for your email messages.<P>
		
		<B>From</B> Who is the email message from?<BR>
		<INPUT TYPE="TEXT" SIZE=25 NAME="admin_name"><P>
		
		<B>Reply-To</B> The reply-to email address of your messages<BR>
		<INPUT TYPE="TEXT" SIZE=25 NAME="admin_email_address"><P>
		
		<FONT COLOR="BB0000"><B>As a test, an email message will also be sent to the above email
		address to make sure everything is working properly.</B></FONT><P>
		
		<INPUT TYPE="SUBMIT" VALUE="Continue">
		</FORM><P>
		!;
		&admin_footer;
	}
}

elsif($FORM{'action'} eq "step4") {
	
	$max_try = 2;
	$admin_email_address = $FORM{'admin_email_address'};
	$to = $admin_email_address;
	$domain = $admin_email_address;
	$domain =~ s/^.*\@//;
	
	if($FORM{'mail_type'}) {
		$smtp_server = $FORM{'smtp_server'};
		$smtp_port = $FORM{'smtp_port'};
		if($FORM{'pop_user'}) {
			$pop_user = $FORM{'pop_user'};
			$pop_password = $FORM{'pop_password'};
			&pop3_connect;
		}
		&smtp_connect;
		&smtp_reset;
	}
	else {
		open(MAIL,"|$FORM{'mailprog'} -t") || &admin_error("Unable to open then mail program: $FORM{'mailprog'}.  Maybe you have specified an incorrect path to your mail program.  Click <A HREF=\"javascript:history.back()\">here</A> to return to step 4");
	}
	
	print MAIL "From: \"$FORM{'admin_name'}\" <$admin_email_address>\015\012";
	print MAIL "To: $to\015\012";
	print MAIL "Subject: Post Office Installation Test\015\012\015\012";
	
	print MAIL "Email test is successful!  Continue to step 4 to finish the installation process.\015\012";
	
	if($FORM{'mail_type'}) {
		print MAIL "\015\012.\015\012";
		$response = <MAIL>;
		&admin_error("Message not accepted for delivery: $response<BR>") if ! $response || $response =~ /^[45]/;
		&smtp_disconnect;
	}
	else {
		close(MAIL);
	}
	
	$script_directory = $ENV{'HTTP_REFERER'};
	$script_directory =~ s/(.+)\/(.*)$/\1/;
	
	&admin_header;
	print qq!
	<FORM ACTION="install.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="step5">
	<INPUT TYPE="HIDDEN" NAME="mail_type" VALUE="$FORM{'mail_type'}">
	<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
	<INPUT TYPE="HIDDEN" NAME="smtp_server" VALUE="$FORM{'smtp_server'}">
	<INPUT TYPE="HIDDEN" NAME="smtp_port" VALUE="$FORM{'smtp_port'}">
	<INPUT TYPE="HIDDEN" NAME="mailprog" VALUE="$FORM{'mailprog'}">
	<INPUT TYPE="HIDDEN" NAME="pop_password" VALUE="$FORM{'pop_password'}">
	<INPUT TYPE="HIDDEN" NAME="pop_user" VALUE="$FORM{'pop_user'}">
	<INPUT TYPE="HIDDEN" NAME="admin_name" VALUE="$FORM{'admin_name'}">
	<INPUT TYPE="HIDDEN" NAME="admin_email_address" VALUE="$FORM{'admin_email_address'}">
	<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
	<H3>Step 4: Last step\!</H3>
	<FONT COLOR="BB0000"><B>We have sent an email message to your email address, $FORM{'admin_email_address'} and it
	should arrive there in a couple of seconds.
	Check your email box for an email message with the subject <I>Post Office Installation Test</I></B>.</FONT><P>
	
	If you have received the email message, then Post Office is working perfectly.  If you have
	not received the email message you can try it again and wait a couple minutes.  If you still
	do not receive the email message, then you have configured Post Office incorrectly and
	will need to double check your information.<P>
	
	Please enter the URL to the directory where the Post Office scripts are located.<BR>
	<INPUT TYPE="TEXT" NAME="script_directory" VALUE="$script_directory" SIZE=50><P>
	
	Please choose a username and password for the administration area.<P>
	
	Username:<BR>
	<INPUT TYPE="TEXT" NAME="username" SIZE=25><P>
	
	Password:<BR>
	<INPUT TYPE="PASSWORD" NAME="password" SIZE=25><P>
	
	Re-Type Password:<BR>
	<INPUT TYPE="PASSWORD" NAME="password2" SIZE=25><P>
	
	<INPUT TYPE="SUBMIT" VALUE="Continue">
	</FORM><P>
	!;
	&admin_footer;
	
}
elsif($FORM{'action'} eq "step5") {
	
	&admin_error("You did not complete all the fields!  Click <A HREF=\"javascript:history.back()\">here</A> to go back.") unless $FORM{'username'} && $FORM{'password'} && $FORM{'script_directory'};
	if($FORM{'password'} ne "$FORM{'password2'}") {
		&admin_error("The password you entered the first time did not match the 2nd time.  Click <A HREF=\"javascript: history.back()\">here</A> try again.");	
	}
	
	if($FORM{'script_directory'} !~ /^http/i) {
		&admin_error("Please include the full URL to the directory that contains your CGI scripts (Eg: http://www.cgiparadise.com/cgi-bin)");
	}
	
	$FORM{'admin_email_address'} =~ s/\@/\\\@/;
	$FORM{'admin_name'} =~ s/\@/\\\@/;
	
	$error = 0;
	chmod(0777, 'config.pl');
	
	$this_dir =~ s/\\/\//g;
	#if(! open(CONFIG,">config.pl")) {
		if(! open(CONFIG,">$FORM{'this_dir'}/config.pl")) {
			$error = 1;
		}
	#}
	foreach $key (keys %FORM) {
		if($key eq "action" || $key eq "password" || $key eq "password2"
				|| $key eq "username") {
			next;
		}
		print CONFIG "\$$key = \"$FORM{$key}\";\n";
	}

	$path_to_perl = "$^X";

	if(! $path_to_perl || $path_to_perl =~ /^perl$/i) {
		$path_to_perl = `which perl`;	
	}
	if(! $path_to_perl || $path_to_perl =~ /^perl$/i) {
		$path_to_perl = `which perl5`;
	}
	if(! $path_to_perl || $path_to_perl =~ /^perl$/i) {
		$path_to_perl = "/usr/bin/perl";
	}
	$path_to_perl =~ s/\\/\//g;
	
	print CONFIG "\$path_to_perl = \"$path_to_perl\";\n";
	print CONFIG q!
	$language = "english";
	$col_width = 60;
	$row_height = 15;
	$continue_when_interrupted = 1;
	$verify_new_users = 1;
	$log_opt_out = 1;
	$allow_duplicates = 0;
	$backup = 7;
	$temp_file_days = 14;
	$max_groups = 10;
	$batch = 100;
	$domain = "";
	$version = "4.0";
	$max_try = 2;
	$max_mail_try = 3;
	$lockfile_maxtry = 10;
	$spellchecker = 1;
	$wait_time = 30;
	$doc_url = "http://www.cgiparadise.com/postoffice/doc4";
	!;
	print CONFIG "\n1;\n # End\n";
	close(CONFIG);
	
	$FORM{'password'} = crypt($FORM{'password'},"PO");
	open(PASS,">$FORM{'base_dir'}/password.txt") || &admin_error("Unable to create the password file.");
	print PASS "$FORM{'username'}:$FORM{'password'}";
	close(PASS);
	
	open(HEAD,">$FORM{'base_dir'}/header.txt") || &admin_error("Unable to create the header file");
	print HEAD qq!
<HTML>
<HEAD>
<TITLE>Post Office $version</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF" TEXT="000000" LINK="FF0000" VLINK="BB0000" ALINK="BB0000">
<CENTER>
<TABLE BGCOLOR="#FFFFFF" WIDTH=600 BORDER=0 CELLSPACING=2 CELLPADDING=5>
<TR BGCOLOR="#FFFFFF"><TD>
<CENTER>
<FONT FACE="Arial" SIZE=6><B>Post Office $version</B></FONT><BR>
</CENTER>
</TD></TR>
<TR BGCOLOR="#FFFFFF"><TD>
<FONT FACE="Arial">
<BR>
	!;
	close(HEAD);
	
	open(FOOT,">$FORM{'base_dir'}/footer.txt") || &admin_error("Unable to create the footer file");
	print FOOT qq!
</FONT>
</TD></TR>
</TABLE></CENTER>
</BODY>
</HTML>
	!;
	close(FOOT);
	
	&admin_header;
	if($error) {
		print qq!
		<H3>Unable to write to the configuration file</H3>
		Post Office was unable to write to the configuration file.  Make sure you have
		changed the permissions on the config.pl to 777 if you are on a Unix server.<P>
		Then press the back button on your browser and try again.<P>
		
		!;
	}
	else {
		print qq!
		<H3>Congratulations\!</H3>
		The installation process is complete.  You may now begin using Post Office.<P>
		
		<B><FONT COLOR="BB0000">Be sure to delete the install.pl from your server for security reasons.</FONT></B><P>
		
		You can now access the Post Office Administration Panel.
		The Post Office Administration panel is where you can manage and maintain your mailing lists
		easily through a web interface.  It also offers quick links to important references such
		as the documentation file.  To begin using Post Office click <A HREF="admin.pl">here</A> to enter the Administration panel.<P>
		!;
	}
	&admin_footer;
}
else {
	&admin_error("Invalid data: Post Office does not understand the parameters you specified");
}