#!/usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on April 2, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#


@months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
@days = qw(Mon Tue Wed Thu Fri Sat Sun);

@Encode_Chars = ('\%', '\+', '\;', '\,', '\=', '\&', '\:', '\s', '\"', '\@');

%Encode_Chars = ('\%',   '%25',
                 '\+',   '%2B',
                 '\;',   '%3B',
                 '\,',   '%2C',
                 '\=',   '%3D',
                 '\&',   '%26',
                 '\:',   '%3A',
                 '\"',   '%22',
                 '\@',   '%40',
                 '\s',   '+');
                 
#----------------------------------------------------------------------------
# Function:    parse_form()
# Description: Parses data submitted from HTML forms and places it in a hash
#              named %FORM
#----------------------------------------------------------------------------
sub parse_form {
	
	if($ENV{'REQUEST_METHOD'} eq "POST") {
   		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
	
	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
	}
   
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $name =~ tr/+/ /;
      $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/\&\&/\&/g;
      #$value =~ s/<!--(.|\n)*-->//g;

      $FORM{$name} = $value;
   }
}


#-----------------------------------------------------------------------
# Function:    admin_header()
# Description: Outputs the header HTML code for the administration pages
#-----------------------------------------------------------------------

sub admin_header {
	my $flag = shift;
	
	print "Content-Type: text/html\n\n";
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Post Office $version Administration</TITLE>
	!;
	
	if($flag) {
		print qq!<script type="text/javascript" language="javascript" src="admin.pl?action=spellchecker"></script>\n!;
	}
	
	print qq!
	</HEAD>
	<BODY BGCOLOR="FFFFFF" TEXT="000000" ALINK="0000FF" VLINK="0000FF" ALINK="0000BB">
	<CENTER>
	<TABLE WIDTH="600" BORDER=0>
	<TR><TD>
	<FONT FACE="Arial" SIZE=2>
	<CENTER><H1>Post Office Administration</H1></CENTER>
	<HR SIZE=1><P>
	!;
}

sub admin_footer {
	print qq!
	<P><HR SIZE=1><P>
	</TD></TR>
	</TABLE>
	</CENTER>
	</BODY>
	</HTML>
	!;
}

sub admin_error {
	my $msg = shift;
	&admin_header;
	print qq!
	<H3>Post Office error</H3>
	$msg
	!;
	&admin_footer;
	exit;
}

sub header {
	
	print "Content-Type: text/html\n\n";
	
	if(-e "$base_dir/header.txt") {
		open(HEADER,"$base_dir/header.txt");
		@MHEADER=<HEADER>;
		close(HEADER);
		print "@MHEADER";
	}
	else {
		print qq!
		<HTML>
		<HEAD>
		<TITLE>Post Office $version</TITLE>
		</HEAD>
		<BODY BGCOLOR="FFFFFF" TEXT="000000" LINK="FF0000" VLINK="BB0000" ALINK="BB0000">
		<CENTER>
		<TABLE BGCOLOR="#FFFFFF" WIDTH=600 BORDER=0 CELLSPACING=2 CELLPADDING=5>
		<TR BGCOLOR="#FFDDDD"><TD>
		<CENTER>
		<FONT FACE="Arial" SIZE=6><B>Post Office $version</B></FONT><BR>
		</CENTER>
		</TD></TR>
		<TR BGCOLOR="#DDDDDD"><TD>
		<FONT FACE="Arial">
		<BR>
		!;
	}
}

sub footer {
	
	if(-e "$base_dir/footer.txt") {
		open(FOOTER,"$base_dir/footer.txt");
		@MFOOTER=<FOOTER>;
		close(FOOTER);
		print "@MFOOTER";
	}
	else {
		print qq!
		</FONT>
		</TD></TR>
		</TABLE></CENTER>
		</BODY>
		</HTML>
		!;
	}
}

sub error {
	my $error = shift;	
	&header;
	print "<B>$TXT{'168'}</b><br>\n";
	print "$error</B><P>\n";
	&footer;
	exit;
}

#------------------------------------------------------------------------------
# Function:    check_pass()
# Description: Checks if the user is logged in.  If the user is not logged in,
#              it logs them in.  Also checks if the user has timed out.
#------------------------------------------------------------------------------

sub check_pass {
	
	$nowtime = time;
	
	if(! -e "$base_dir/temp") {
    	mkdir("$base_dir/temp",0777) || &admin_error("$TXT{'1'}: temp");
    }
    
	# Lets check for users that have timed out
	opendir(BASE,"$base_dir/temp") || &admin_error("$TXT{'0'}");
	while($file = readdir(BASE)) {
		if($file =~ /(.*)\.session$/) {
			open(FILE,"$base_dir/temp/$file") || &admin_error("$TXT{'2'} $file");
			chomp($mytime =<FILE>);
			close(FILE);
			
			if($nowtime - $mytime > 7200) {
				# If the session is too old, time them out
				unlink("$base_dir/temp/$file");
			}
		}
	}
	closedir(BASE);
	
	$cookie = &getcookie("POID");
	
	if(! $cookie) {
		# If the does not exist, lets log them in
		
		open(FILE,"$base_dir/password.txt") || &admin_error("$TXT{'2'} password.txt");
		my $line =<FILE>;
		chomp($line);
		close(FILE);
	
		my ($username,$password) = split(/\:/,$line);
		my $epassword = crypt($FORM{'password'},"PO");
		
		if($FORM{'username'} eq "$username" && $password eq "$epassword") {
			
			my $nowtime = time;
			
			srand( time() ^ ($$ + ($$ << 15)) );
			$rnum = int(rand(10000));
			
			my $session = $nowtime + $rnum;
			open(FILE,">$base_dir/temp/$session.session") || &admin_error("$TXT{'1'} $session.session");
			print FILE "$nowtime";
			close(FILE);
			&setcookie("$session");
		}
		else {
			# Invalid username or password
			&admin_header;
			
			if($FORM{'username'} && $FORM{'password'}) {
				print qq!
				<H3>Invalid username or password</H3>
				!;
			}
			else {
				print qq!
				<H3>Login</H3>
				!;	
			}
			
			print qq!
			$TXT{'32'}</B><P>
			<FORM ACTION="admin.pl" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="main">
			<INPUT TYPE="TEXT" SIZE=15 NAME="username"> $TXT{'33'}<BR>
			<INPUT TYPE="PASSWORD" SIZE=15 NAME="password"> $TXT{'34'}<BR><BR>
			<INPUT TYPE="SUBMIT" VALUE="$TXT{'66'}">
			</FORM>
			!;
			&admin_footer;
			exit;
		}
	}
	else {
		# If we found a cookie, lets check the session

		if(-e "$base_dir/temp/$cookie.session") {
			
			# If everything is ok, update the session time

			open(FILE,">$base_dir/temp/$cookie.session") || &admin_error("$TXT{'1'} $cookie.session");
			print FILE "$nowtime";
			close(FILE);

		}
		else {
			# If the session file isn't found, log them in

			&setcookie("0");
			&admin_header;
			print qq!
			<H3>$TXT{'169'}</H3>
			<B>$TXT{'32'}</B><P>
			<FORM ACTION="admin.pl" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="main">
			<INPUT TYPE="TEXT" SIZE=15 NAME="username"> $TXT{'33'}<BR>
			<INPUT TYPE="PASSWORD" SIZE=15 NAME="password"> $TXT{'34'}<BR><BR>
			<INPUT TYPE="SUBMIT" VALUE="$TXT{'66'}">
			</FORM>
			!;
			&admin_footer;
			exit;
		}	
	}
}


sub getcookie {
	
	my $cookie_name = shift;
	$r = 0;
	
	@cookies = split(/\; /, $ENV{'HTTP_COOKIE'});
	
	foreach $cookie (@cookies) {
			
		($name, $value) = split(/=/, $cookie);
			
		#foreach $char (@Cookie_Decode_Chars) {
		#	$name =~ s/$char/$Cookie_Decode_Chars{$char}/g;
		#	$value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
		#}
		if($name eq "$cookie_name") {
			$r = $value;
			last;
		}
	}
	
	return $r;
}

sub setcookie {
	
	my $session = shift;
	
	#foreach $char (@Cookie_Encode_Chars) {
	#	$session =~ s/$char/$Cookie_Encode_Chars{$char}/g;
	#}
	
	print "Set-Cookie: POID=" . $session . "\n";
}

sub encode {
	# URI ENCODE
	my $value = shift;
	foreach $char (@Encode_Chars) {
		$value =~ s/$char/$Encode_Chars{$char}/g;
	}
	return $value;
}

sub mail_error {
	my $msg = shift;
	
	$SECOND{$to} += 1;
	redo MAILLOOP if $SECOND{$to} <= $max_mail_try;
	&admin_error("$msg");
}

sub smtp_connect {
	
	$max_try_c = $max_try;
	while(! socket(MAIL, PF_INET, SOCK_STREAM, getprotobyname('tcp')) && $max_try > 0) {
		$max_try--;
	}
	if(! $max_try) {
		&admin_error("Unable to create socket");
	}
	
	$remote_address = inet_aton($smtp_server);
	$paddr = sockaddr_in($smtp_port, $remote_address);
	
	while(! connect(MAIL, $paddr) && $max_try_c > 0) {
		$max_try_c--;
	}
	if(! $max_try_c) {
		&admin_error("Unable to connect to Smtp server <I>$smtp_server</I>.  Maybe you have specified an invalid hostname or your server is temperarily down.  Click <A HREF=\"javascript: history.back()\">here</A> to go back and try again.");
	}
	
	select((select(MAIL), $| = 1)[0]);
	#$oldfh = select(MAIL); $| = 1; select($oldfh);
	
	$response = <MAIL>;
	
	&admin_error("No response from the server: $response")  if  ! $response || $response =~ /^[45]/;

	$mydomain = $domain || $FORM{'reply-to'} || $FORM{'from'};
	$mydomain =~ s/.+\@//;
	
	print MAIL "HELO $mydomain\015\012";
	$response = <MAIL>;
	
	&admin_error("Server won't say hello: $response") if ! $response || $response =~ /^[45]/;
	
}

sub smtp_disconnect {
	#close(LIST);
	print MAIL "quit";
	close(MAIL);
}

sub smtp_reset {
	
	print MAIL "RSET\015\012";
	$response = <MAIL>;
	
	&admin("Unable to reset connection.  Click <A HREF=\"javascript: history.back()\">here</A> to go back and try again.") if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>");
	}

	print MAIL "MAIL FROM:<$admin_email_address>\015\012";
	$response = <MAIL>;
	&error("Invalid Sender.  Make sure that you have specified a valid email address and that you have access to the SMTP server.Click <A HREF=\"javascript: history.back()\">here</A> to go back.") if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>");
	}

	print MAIL "RCPT TO:<$to>\015\012";
	$response = <MAIL>;
	&error("Invalid Recipient: &lt;$to&gt;<BR>$response<BR>Maybe you don't have access to this mail server or maybe the recipient email address is an invalid email address. Click <A HREF=\"javascript: history.back()\">here</A> to go back.\n") if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>");
	}

	#Let the server know we're gonna start sending data
	print MAIL "DATA\015\012";
	$response = <MAIL>;
	&error("Server Not ready to accept data: $response<BR>  Please try again.\n") if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>");
		
	}
}

sub file_lock {
	
    my $name = shift;
    my $lock_file = "$base_dir/temp/$name\.lock";
    
    if(! -e "$base_dir/temp") {
    	mkdir("$base_dir/temp",0777) || &error("$TXT{'1'}: temp");
    }

    while(-e $lock_file) {
        if($i < $lockfile_max_try) {
        	sleep(1);
        	$i++;
        }
        else {
        	unlink("$lock_file") || &error("$TXT{'162'} $name.lock");
        }
    }
    
    open(LOCK, ">$lock_file") || &error("$TXT{'1'} $name.lock");
    print LOCK "Post Office Lock File\n";
    close(LOCK);
}

sub file_unlock {
    my $name = shift;
    my $lock_file = "$base_dir/temp/$name\.lock";
    unlink($lock_file);
}

sub getdate {
	my $mytime = shift;
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($mytime);
	$year += 1900;
	$wday -= 1;
	return "$months[$mon] $mday, $year ($days[$wday])";
}

sub begin_admin {

	my $mytime = time;
	
	if(! -e "$base_dir/regit.num") {
	
		if(! -e "$base_dir/time.num") {
			open(REG,">$base_dir/time.num") || &admin_error("$TXT{'1'} time.num");
			print REG "$mytime";
			close(REG);
		}
	
		my $regtime;
		open(REG,"$base_dir/time.num") || &admin_error("$TXT{'2'} time.num");
		chomp($regtime =<REG>);
		close(REG);	
	
		if($mytime - $regtime > 44 * 24 * 60 * 60) {
			return 0;
		}
		else {
			return 1;
		}
	}
	else {
		open(REG,"$base_dir/regit.num") || &admin_error("$TXT{'2'} reg.nums");
		chomp($regnumber =<REG>);	
		close(REG);
		return 1;
	}
}

sub checksyntax {
	
	my $address = shift;
	my($username, $hostname) = split('@',$address);
	
	if(! $hostname) {
		return 0;
	}
	$cset = '[0-9a-zA-Z\-_]';
	if($username =~ /^(?:$cset+\.)*$cset+$/xo) {
		$uok = 1;
	}
	else {
		$uok = 0;
	}
	
	if($uok) {
		$cset = '[0-9a-zA-Z\-_]';
		if($hostname =~ /^(?:$cset+\.)+$cset+$/xo) {
			$uok = 1;
		}
		else {
			$uok = 0;
		}
	}
	
	return $uok;
}

#sub pop3_connect {
	
	#my $error = shift;
	
	#use POP3Client;
	#$pop = new Mail::POP3Client( HOST  => "$smtp_server" );
	#$pop->User("$pop_user");
	#$pop->Pass("$pop_password");
	
	#if(! $pop->Connect() && ! $error) {
	#	$message = $pop->Message();
	#	&admin_error("Unable to connect to your pop3 mail server<P>$message");
	#}
	#$pop->Close();
#}

sub spellchecker {

print q!// (c) 2000 SpellChecker.net, Inc.  All rights reserved.  www.SpellChecker.net
// PLEASE DO NOT EDIT THIS FILE. THE SYSTEM MIGHT FAIL TO WORK IF THE FILE WAS CHANGED.

// (c) 2000 SpellChecker.net, Inc.  All rights reserved.  www.SpellChecker.net
//
//var service_host = "http://service.host.name/and_path_if_requierd";
//
var schema_url 		= "";
var spp_langs		= "";
var service_host	= "http://www.spellchecker.net/spellcheck/";
var customerid		= "0395238580";
var schema			= "7";
var bnr				= "1";
var c_lang			= "";
var ci_lang			= "";
var int_lang		= "en";
var hide 			= "";
var doc_blank		= "/lf/blank.html";
var doc_blankform	= "/lf/blankform.html";
var doc_process		= "script/ssrv.cgi";

var mid_doc;
var is_window_opened = false;

function doSpell( lang, ctrl, url, force_reload, intlang, fctrlname, saw, unloadurl) {
	var isMSIE = (navigator.appName == 'Microsoft Internet Explorer');
	var Ver = navigator.appVersion;
	if ( (isMSIE && parseInt (navigator.appVersion) < 4) ) {
		alert("Our SpellChecker feature does not support Internet Explorer 3.0.  However, it does support the following browsers: IE 4+, Netscape 4+ ( 6.0).");
		return;
	}
	if ( (navigator.appName == 'Netscape') && 
	     ( (navigator.appVersion.indexOf('4.5') \!= -1) || (navigator.appVersion.indexOf('3.0') \!= -1) ) )
	{
		alert('Sorry, currently we do not support Netscape Navigator 3.0, 4.5, 6.0, Internet Explorer 3.0.\nPlease upgrade your browser.');
		return;
	}
	if ( c_lang \!= '' ) lang = c_lang;
	if ( intlang == '' ) intlang = int_lang;
	
	var ctrlObj;
	var ctrlName 	= '';
	var formNum	 	= -1;
	var wWidth   	= 488;
	var wHeight  	= (hide.indexOf('[sw]') == -1)?440:260;
	var spellWin;
	var botf		= 159;
	var s			= '';

	if (ctrl.constructor && ctrl.constructor == String)
	{
		ctrlName = ctrl;
		formNum  = -1;
		
		ctrlObj  = eval(ctrl);
		wWidth   = ctrlObj.clientWidth < wWidth ? wWidth : ctrlObj.clientWidth;
		wHeight  = (ctrlObj.clientHeight > wHeight ? ctrlObj.clientHeight : wHeight);
	}
	else
	{
		var i = 0;
		for (i = 0; i < document.forms.length; i++)
		{
			if (document.forms[i] == ctrl.form)
				break;
		}
		if (i==document.forms.length)
			formNum = -1;
		else
			formNum = i;

		ctrlName = ctrl.name;
		ctrlObj  = ctrl;
	}
	if ((ctrlObj.value ? ctrlObj.value : ctrlObj.innerHTML) == '')
	{
		alert('Nothing to check.');
		return
    }

	if ( lang == '' ) lang = 'en';
	if ( window.name == '' ) window.name = 'sp_ch_opener_window';
	wndname = window.name;
	if (hide.indexOf('[eb]') \!= -1)
		spellWin = window;
	else
		spellWin = window.open("", "spch" + getHostStr(document.location.host), "width=" + wWidth + ",height=" + wHeight + ",toolbar=no,resizable=no");
	var d = spellWin.document;

if (\!is_window_opened || hide.indexOf('[dc]') == -1) {
	if (hide.indexOf('[ch]') \!= -1)
	{
		s = 
		'<script>' + 
		'\nvar cFlag = 0;' +
		'\nfunction uHandler(){if (cFlag == 1){cFlag=0;open("' + url + '?cmd=terminate&txt_ctrl=' + ctrl.name + '");}}' +
		'\nfunction lHandler(){cFlag=1;}' +
		'</script\>' +
		'<title>Spellchecker.net</title>' + 
		'<frameset onload="javascript:lHandler()" onUnload="javascript:uHandler()" rows="'+((bnr==1)?96:30)+',*,'+botf+',0" frameborder="No" framespacing=0 border=0>'
	}
	else
	{
		s =
		'<title>Spellchecker.net</title>' +                       
		'<frameset rows="'+((bnr==1)?96:30)+',*,'+botf+',0'+((hide.indexOf('[dc]') \!= -1)?',0':'')+'" frameborder="No" framespacing=0 border=0>'
	}	
		s +=
		'    <frame name="navbar" src="' + service_host + doc_blank + '" marginwidth="2" marginheight="0" noresize scrolling="no" frameborder="no" framespacing=0>' +
		'    <frame name="mid" src="about:blank" marginwidth="0" marginheight="0" noresize scrolling="auto" frameborder="no" framespacing=0>' +
		'    <frame name="bot" src="' + service_host + doc_blankform + '" marginwidth=1 marginheight=1 noresize scrolling="auto" frameborder="no" framespacing=0>' +
		'    <frame name="spellsuggestall" src="' + service_host + doc_blank + '" marginwidth=1 marginheight=1 noresize scrolling="no" frameborder="no" framespacing=0>';
		if (hide.indexOf('[dc]') \!= -1)
			s +=
			'    <frame name="unload" src="' + unloadurl + '" marginwidth=1 marginheight=1 noresize scrolling="no" frameborder="no" framespacing=0>';
		s += '</frameset\>';
	d.open();
	d.write(s);
	d.close();

	d = spellWin.frames[1].document;
}
	if ( d ) {
		
if (\!is_window_opened || hide.indexOf('[dc]') == -1) {
		var s = 
			'<body>' +
			'<form name=frmSpell method=post action="' + service_host + doc_process + '" lang=' + lang + '>' +
			'<input type=hidden name=slang value="">' +
			'<input type=hidden name=intlang value="">' +
			'<input type=hidden name=text value="">' +
			'<input type=hidden name=cmd value="">' +
			'<input type=hidden name=trg_url value="">' +
			'<input type=hidden name=trg_wnd value="">' +
			'<input type=hidden name=txt_ctrl value="">' +
			'<input type=hidden name=svc_time value="">' +
			'<input type=hidden name=statinfo value="">' +
			'<input type=hidden name=customerid value="">' +
			'<input type=hidden name=schema value="">' +
			'<input type=hidden name=schema_url value="">' +
			'<input type=hidden name=spp_langs value="">' +
			'<input type=hidden name=bnr value="">' +
			'<input type=hidden name=hide value="">' +
			'<input type=hidden name=saw value="">' +
			'</form>' +
			'<center><h2>Loading...</h2>';
			if (hide.indexOf('[cp]') \!= -1)
				s = s + '<a href="" onclick="parent.opener.'+fctrlname+'.focus(); parent.close() //document.location = \''+service_host+doc_process+'?cmd=eos&customerid='+customerid+'&sessionid=0&bnr='+bnr+'&schema='+schema+'&hide='+hide+'\'; return false//parent.close(); return false">Abort SpellChecker</a>&nbsp;&nbsp;' +
					'<a href="" onclick="eval(\'parent.opener.\'+(parent.opener.'+saw+'.send_action)); parent.opener.focus(); document.location = \''+service_host+doc_process+'?cmd=eos&customerid='+customerid+'&sessionid=0&bnr='+bnr+'&schema='+schema+'&hide='+hide+'\'; return false">Send Without Checking</a>';
		    s =	s + '<center></center>' +
			'</body>';
                
		d.open();
		d.writeln(s);
		d.close();
}                	
		var f_dst;
		if (\!is_window_opened || hide.indexOf('[dc]') == -1)
			f_dst = d.forms[0];
		else {
			f_dst = spellWin.frames[4].document.forms[0];
			f_dst.action = service_host + doc_process;
		}

		f_dst.cmd.value = 'spell';
		f_dst.slang.value = lang;
		f_dst.intlang.value = intlang;
		f_dst.text.value = ctrlObj.value ? ctrlObj.value : ctrlObj.innerHTML;
		f_dst.trg_url.value = url;
		f_dst.trg_wnd.value = wndname;
		if ( fctrlname ) {
			f_dst.txt_ctrl.value = fctrlname;
		} else {
			if (formNum \!= -1)
				f_dst.txt_ctrl.value = force_reload ? 'document.forms[' + i + '][\'' + ctrlName + '\']' : '';
			else
				f_dst.txt_ctrl.value = force_reload ? ctrlName : '';
		}
		f_dst.svc_time.value = (new Date()).getTime();
		f_dst.customerid.value = customerid?customerid:'';
		f_dst.schema.value = schema?schema:'';
		f_dst.schema_url.value = schema_url;
		f_dst.spp_langs.value = spp_langs;
		f_dst.bnr.value = bnr;
		f_dst.hide.value = hide;
		f_dst.saw.value = saw;
		f_dst.submit();
		spellWin.focus();

		if (hide.indexOf('[dc]') \!= -1)	is_window_opened = true;
	}
}
function getHostStr(str)
{
    var res = getSplitStr(str, ".");
    res = getSplitStr(res, ":");
    res = getSplitStr(res, "-");
    return res;
}
function getSplitStr(str, del)
{
    var res = "";
    var arr = str.split(del);
    for(var i = 0; i < arr.length; i++)
    {
      if (res \!= "")
        res = res +"_";
      res = res + arr[i];
    }
    return res;
}
function set_mid_doc(doc)
{
	mid_doc = doc;
}
!;
}

1;