#!/usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on April 2, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#


BEGIN {
	if($0 !~ /^manager\.(cgi|pl)$/i && $0) {
		$this_dir = $0;
	}
	elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
		$this_dir = $ENV{'SCRIPT_FILENAME'};
	}
	elsif($ENV{'PATH_TRANSLATED'}) {
		$this_dir = $ENV{'PATH_TRANSLATED'};
	}
	$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
	$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'library.pl';
require 'config.pl';
require "$language.lib";

use Socket;

&parse_form;

#if($pop_user && $mail_type) {
#	&pop3_connect(1);
#}

if($backup) {
	if(! -e "$base_dir/backup") {
		mkdir("$base_dir/backup",0777) || &error("$TXT{'1'} backup");
		open(BTIME,">$base_dir/backup/last_backup.txt") || &error("$TXT{'1'} last_backup.txt");
		print BTIME "";
		close(BTIME);
	}

	open(BTIME,"$base_dir/backup/last_backup.txt") || &error("$TXT{'2'} last_backup.txt");
	$last_backup =<BTIME>;
	close(BTIME);

	chomp($last_backup);

	$mytime = time();
	$mytime -= $last_backup;
	$backup = $backup * 24 * 60 * 60;

	if($mytime > $backup) {
		&file_lock(".backup");
		opendir(LISTS, "$base_dir") || &error("$TXT{'2'} $base_dir");
		while($file = readdir(LISTS)) {
			if($file =~ /.+\..+/ && $file !~ /lock$/ && $file !~ /session$/) {
				open(FILE,"$base_dir/$file") || &error("$TXT{'2'} $file");
				open(BACKUPFILE,">$base_dir/backup/$file") || &error("Unable to write Post Office file: $base_dir/backup/$file");
				while($line =<FILE>) {
					print BACKUPFILE "$line";
				}
				close(BACKUPFILE);
				close(FILE);
			}
		}
		close(LISTS);	
		$mytime = time();
	
		open(BTIME,">$base_dir/backup/last_backup.txt") || &error("$TXT{'1'} last_backup.txt");
		print BTIME "$mytime";
		close(BTIME);
		&file_unlock(".backup");
	}
}


if($FORM{'action'} =~ /add/i || $FORM{'action'} eq "" || $FORM{'action'} =~ /^\w{2}\d{7}$/) {
	
	if(! $FORM{'email'} && $FORM{'action'} !~ /^\w{2}\d{7}$/) {
		&error("$TXT{'5'}");
	}
	
	if(! &checksyntax("$FORM{'email'}") && $FORM{'action'} !~ /^\w{2}\d{7}$/) {
        &error("$TXT{'6'}");
    }
    
    if($FORM{'email'} =~ /\s$/) {
    	chop($FORM{'email'});
    }
    
    $FORM{'required'} =~ s/\s*\,\s*/\,/g;
    @required = split(/\,/, $FORM{'required'});
    foreach $require (@required) {
    	if(! $FORM{$require} && $FORM{'action'} !~ /^\w{2}\d{7}$/) {
    		&error("$TXT{'7'}");
    	}
    }
    
    $join_groups = "";
    $y = 0;
    $message = "";
    $errors = "";
    undef(@WARNING);
    
    
    for($i=1;$i<=$max_groups;$i++) {
    	$field = "group$i";
    	if($log_opt_out && $FORM{'action'} !~ /^\w{2}\d{7}$/ && -e "$base_dir/$FORM{$field}.out" && $FORM{'proceed'} ne "yes") {
    		if($FORM{$field} ne "") {
    			if(! -e "$base_dir/$FORM{$field}.info") {
    				# The list does not exist, give an error message.
    				$txt = $TXT{'8'};
    				$txt =~ s/<<groupname>>/$FORM{$field}/g;
    				&error("$txt");
    			}
    		
    			open(OPTOUT,"$base_dir/$FORM{$field}.out") || &error("$TXT{'2'} $FORM{$field}.out");
    			while($line =<OPTOUT>) {
    				chomp($line);
    				if($line =~ /$FORM{'email'}/i) {
    					push(@WARNING,"$FORM{$field}");
    					last;
    				}
    			}
    			close(OPTOUT);
    		
    		}
    	}
    	$warning = @WARNING;
    	if($warning) {
    		&header;
    		print qq!
    		<FORM ACTION="manager.pl" METHOD="POST">
    		$TXT{'9'}
    		$TXT{'10'}
    		!;
    		
    		$n = 1;
    		foreach $list (@WARNING) {
    			print qq!
    			<INPUT TYPE="CHECKBOX" NAME="group$n" VALUE="$list" CHECKED="CHECKED"> $list<BR>
    			!;
    			$n++;
    		}
    		foreach $key (keys %FORM) {
    			if($key !~ /^group\d*$/) {
    				print qq!
    				<INPUT TYPE="HIDDEN" NAME="$key" VALUE="$FORM{$key}">
    				!;
    			}
    		}
    		
    		print qq!
    		<BR>
    		<INPUT TYPE="HIDDEN" NAME="proceed" VALUE="yes">
    		<INPUT TYPE="SUBMIT" VALUE="$TXT{'11'}">
    		</UL>
    		</FORM>
    		!;
    		&footer;
    		exit;
    	}
    	if($log_opt_out && $FORM{'proceed'} eq "yes") {
    		# Delete the user
    		if(-e "$base_dir/$FORM{$field}.out") {
    			&file_lock("$FORM{$field}");
    			open(OUT,"$base_dir/$FORM{$field}.out") || &error("$TXT{'2'} $FORM{$field}.out");
    			@OUTDAT =<OUT>;
    			close(OUT);
    			
    			open(OUT,">$base_dir/$FORM{$field}.out") || &error("$TXT{'1'} $FORM{$field}.out");
    			foreach $out_email (@OUTDAT) {
    				chomp($out_email);
    				if($out_email !~ /$FORM{'email'}/i) {
    					print OUT "$out_email\n";
    				}
    			}
    			close(OUT);
    			&file_unlock("$FORM{$field}");
    			undef(@OUTDAT);
    		}
    	}
    }
    
    if($verify_new_users && $FORM{'action'} =~ /^\w{2}\d{7}$/) {
    	if(-e "$base_dir/pending.tmp") {
    		&file_lock("pending");
    		open(TMP,"$base_dir/pending.tmp") || &error("$TXT{'2'} pending.tmp");
    		@TMPFILE =<TMP>;
    		close(TMP);
    		
    		open(TMP,">$base_dir/pending.tmp") || &error("$TXT{'2'} pending.tmp");
    		$found = 0;
    		foreach $line (@TMPFILE) {
    			chomp($line);
    			($email,$num,$histime,$tempfields) = split(/\&\&/,$line);
    			$now = time;
    			$timediff = $now - $histime;
    			if($num eq "$FORM{'action'}") {
    				$found = 1;
    				print TMP "$line\n";
    				$FORM{'email'} = $email;
    				$mytempfields = $tempfields;
    				#last;
    			}
    			elsif($timediff < $temp_file_days * 24 * 60 * 60) {
    				print TMP "$line\n";
    			}
    		}
    		
    		close(TMP);
    		&file_unlock("pending");
    	}
    	if($found) {
    		@tempfields = split(/\|\|/,$mytempfields);
    		foreach $tempfield (@tempfields) {
    			($field,$value) = split(/=/,$tempfield);
    			$FORM{$field} = $value;
    		}
    	}
    	else {
    		&error("$TXT{'12'}");
    	}
    }
    
    if(! $FORM{'autoresponder'}) {
    	for($i=1;$i<=$max_groups;$i++) {
    		$field = "group$i";
    		if($FORM{$field} ne "") {
    			$FORM{'autoresponder'} = $FORM{$field};
    			last;
    		}
    	}
    	#$FORM{'autoresponder'} = "$FORM{'group1'}";
    }
    
    
    MAINLOOP: for($i=1;$i<=$max_groups;$i++) {
    	$field = "group$i";
    	if($FORM{$field} ne "") {
    		$y += 1;
    		if(! -e "$base_dir/$FORM{$field}.info") {
    			# The list does not exist, give an error message.
    			$txt = $TXT{'8'};
    			$txt =~ s/<<groupname>>/$FORM{$field}/g;
    			&error("$txt");
    		}
    
    		if(! -e "$base_dir/$FORM{$field}.dat") {
    			# If the data file doesn't exist yet, lets create it
	    		open(LIST,">$base_dir/$FORM{$field}.dat") || &error("$TXT{'1'} $FORM{$field}.dat");
    			close(LIST);
    		}
            
    		if(! $allow_duplicates) {
    			# Check for duplicate email addresses
    			open(LIST,"$base_dir/$FORM{$field}.dat") || &error("$TXT{'2'} $FORM{$field}.dat");
    			while($line =<LIST>) {
    				if($line =~ /$FORM{'email'}/i) {
    					$txt = $TXT{'13'};
    					$txt =~ s/<<groupname>>/$FORM{$field}/g;
    					$errors .= "$txt";
    					next MAINLOOP;
    				}
    			}
    			close(LIST);
    		}

    		&file_lock("$FORM{$field}");
    
    		open(INFO, "$base_dir/$FORM{$field}.info") || &error("$TXT{'2'} $FORM{'group'}.info");
    		@MYINFO =<INFO>;
    		close(INFO);
    
    		chomp($MYINFO[0]);
    		chomp($MYINFO[1]);
    
    		$MYINFO[0]++;
    		@fields = split(/\&\&/,$MYINFO[1]);
    
    		$entry = "";
    
    		foreach $myfield (@fields) {
    			if($myfield eq "date") {
    				$FORM{$myfield} = &getdate(time);
    			}
    			elsif($myfield eq "ip") {
    				$FORM{$myfield} = $ENV{'REMOTE_ADDR'};
    			}
    			
    			$FORM{$myfield} =~ s/(\n|\r)/\ /g;
    			$entry .= "$FORM{$myfield}&&";
    		}
    
    		chop($entry);
    		chop($entry);
    		
        	foreach $myfield (@fields) {
    	    	$FIELDS{$myfield} = $FORM{$myfield};
    	    }
    	    	
    		if(! $verify_new_users || $FORM{'action'} =~ /^\w{2}\d{7}$/) {
    
    			if(-e "$base_dir/autoresponders/$FORM{$field}.add" && $FORM{'autoresponder'} eq "all") {
    				open(RESPOND,"$base_dir/autoresponders/$FORM{$field}.add") || &error("$TXT{'2'} $FORM{$field}.add");
					@MESSAGE =<RESPOND>;
					close(RESPOND);
		
					chomp($from = shift(@MESSAGE));
					chomp($FORM{'reply-to'} = shift(@MESSAGE));
					chomp($subject = shift(@MESSAGE));
					chomp($html = shift(@MESSAGE));
					$to = $FORM{'email'};
		
					$emessage = join("",@MESSAGE);
    	
    				if($mail_type) {
    					&smtp_connect;
						&smtp_reset;
					}
					else {
						open(MAIL,"|$mailprog -t") || &error("$TXT{'3'} $mailprog");
					}
		
					$myemail = &encode("$FORM{'email'}");
					$FIELDS{'remove link'} = "$script_directory/manager.pl?action=delete&email=$myemail&group1=$FORM{$field}";
		
					foreach $field (keys %FIELDS) {
						$emessage =~ s/<<$field>>/$FIELDS{$field}/g;
						$subject =~ s/<<$field>>/$FIELDS{$field}/g;
					}
		
					if($html eq "on") {
						print MAIL "Content-Type: text/html\015\012";
					}
		
					print MAIL "From: \"$from\" <$FORM{'reply-to'}>\015\012";
					print MAIL "Subject: $subject\015\012";
					print MAIL "To: $to\015\012"; 
					print MAIL "\015\012";
		
					# For qmail users
					$emessage =~ s/\015\012/\n/gs;
					$emessage =~ s/\015/\n/gs;
					$emessage =~ s/\n/\015\012/gs;
		
					print MAIL "$emessage";
					
					if($mail_type) {
						print MAIL "\015\012.\015\012";
	
						$response = <MAIL>;
						&error("Message not accepted for delivery: $response &lt\;$to&gt\;<BR> Please try again") if ! $response || $response =~ /^[45]/;
						if ($response =~ /^221/){
							close(MAIL);
 							&error("Server disconnected: $response");
						}
    					&smtp_disconnect;
    				}
    				else {
    					close(MAIL);
    				}
    			}
    			
    			if(-e "$base_dir/autoresponders/$FORM{$field}.notify" && $FORM{'autoresponder'} eq "all") {
    			    open(RESPOND,"$base_dir/autoresponders/$FORM{$field}.notify") || &error("$TXT{'2'} $FORM{$field}.notify");
					@MESSAGE =<RESPOND>;
					close(RESPOND);
		
					chomp($from = shift(@MESSAGE));
					chomp($FORM{'reply-to'} = shift(@MESSAGE));
					chomp($subject = shift(@MESSAGE));
					chomp($html = shift(@MESSAGE));
					$to = $admin_email_address;
		
					$emessage = join("",@MESSAGE);
		
    				if($mail_type) {
    					&smtp_connect;
						&smtp_reset;
					}
					else {
						open(MAIL,"|$mailprog -t") || &error("$TXT{'3'} $mailprog");
					}

					foreach $field (keys %FIELDS) {
						$emessage =~ s/<<$field>>/$FIELDS{$field}/g;
						$subject =~ s/<<$field>>/$FIELDS{$field}/g;
						$from =~ s/<<$field>>/$FIELDS{$field}/g;
						$FORM{'reply-to'} =~ s/<<$field>>/$FIELDS{$field}/g;
					}
		
					if($html eq "on") {
						print MAIL "Content-Type: text/html\015\012";
					}
		
					print MAIL "From: \"$from\" <$FORM{'reply-to'}>\015\012";
					print MAIL "Subject: $subject\015\012";
					print MAIL "To: $to\015\012"; 
					print MAIL "\015\012";
		
					# For qmail users
					$emessage =~ s/\015\012/\n/gs;
					$emessage =~ s/\015/\n/gs;
					$emessage =~ s/\n/\015\012/gs;
		
					print MAIL "$emessage";
			
					# END OF EMAIL MESSAGE
			
					if($mail_type) {
						print MAIL "\015\012.\015\012";
	
						$response = <MAIL>;
						&error("Message not accepted for delivery: $response<BR> Please try again") if ! $response || $response =~ /^[45]/;
						if ($response =~ /^221/){
								close(MAIL);
 								&error("Server disconnected: $response");
						}
    					&smtp_disconnect;
    				}
    				else {
    					close(MAIL);
    				}
    			}
    			
    			open(LIST, ">>$base_dir/$FORM{$field}.dat") || &error("$TXT{'1'} $FORM{$field}.dat");
    			print LIST "$entry\n";
    			close(LIST);
    	    	
    	    	#@datafields = split(/\&\&/,$entry);

    			open(INFO, ">$base_dir/$FORM{$field}.info") || &error("$TXT{'1'} $FORM{$field}.info");
    			print INFO "$MYINFO[0]\n";
    			print INFO "$MYINFO[1]";
	    		close(INFO);
    		}
    		
    		$message .= "<LI> $FORM{$field}<BR>\n";
    		
    		&file_unlock("$FORM{$field}");
    		$join_groups .= "$field=$FORM{$field}||";
    	}
	}
	# END LOOP
	
    chop($join_groups);
    chop($join_groups);
    
    if(! $y) {
    	&error("$TXT{'14'}");
    }
    	
	if($verify_new_users && $FORM{'action'} !~ /^\w{2}\d{7}$/ && $message ne "") {
   		

    	&file_lock("pending");
				
    	if(! -e "$base_dir/pending.tmp") {
	    	open(LIST,">$base_dir/pending.tmp") || &error("$TXT{'1'} pending.tmp");
    		print LIST "";
    		close(LIST);
    	}
    			
    	$now = time();
    	
    	$entry = "";	
    	foreach $key (keys %FIELDS) {
    		$entry .= "$key=$FIELDS{$key}||";
    	}
    	
    	srand( time() ^ ($$ + ($$ << 15)) );
    	$num = int(rand(9));
    	$num .= int(rand(9));
    	$num .= int(rand(9));
    	$num .= int(rand(9));
    	$num .= int(rand(9));
    	$num .= int(rand(9));
    	$num .= int(rand(9));
    	$confcode = substr($FORM{'email'},0,2);
    	$confcode =~ s/\W/A/g;
    	$confcode .= "$num";
    
    	$entry .= "$join_groups||autoresponder=$FORM{'autoresponder'}||verify_redirect=$FORM{'verify_redirect'}";
    	
    	open(LIST, ">>$base_dir/pending.tmp") || &error("$TXT{'1'} pending.tmp");
    	print LIST "$FORM{'email'}&&$confcode&&$now&&$entry\n";
    	close(LIST);
    			
    	&file_unlock("pending");
    	
    	$to = $FORM{'email'};
    	
    	if(! -e "$base_dir/autoresponders/$FORM{'autoresponder'}.verify") {
    		open(RESPOND,"$base_dir/autoresponders/all.verify") || &error("$TXT{'2'} all.verify");
    	}
    	else {	
    		open(RESPOND,"$base_dir/autoresponders/$FORM{'autoresponder'}.verify") || &error("$TXT{'2'} $FORM{'autoresponder'}.verify");
    	}
    	
		@MESSAGE =<RESPOND>;
		close(RESPOND);
			
		chomp($from = shift(@MESSAGE));
		chomp($FORM{'reply-to'} = shift(@MESSAGE));
		chomp($subject = shift(@MESSAGE));
		chomp($html = shift(@MESSAGE));
		$emessage = join("",@MESSAGE);
		
		#open(INFO,"$base_dir/$FORM{'autoresponder'}.info") || &error("Could not open Post Office file: $FORM{'autoresponder'}.info");
		#@MYINFO =<INFO>;
		#close(INFO);
		
		#@fields = split(/\&\&/,$MYINFO[1]);
		
   		if($mail_type) {
    		&smtp_connect;
    		&smtp_reset;
    	}
    	else {
    		open(MAIL,"|$mailprog -t") || &error("$TXT{'3'} $mailprog");
   	 	}	
		
		$FORM{'verify_redirect'} = &encode("$FORM{'verify_redirect'}");
		$FORM{'autoresponder'} = &encode("$FORM{'autoresponder'}");
		$FIELDS{'verify link'} = "$script_directory/manager.pl?action=$confcode";
		
		foreach $key (keys %FIELDS) {
			$emessage =~ s/<<$key>>/$FIELDS{$key}/g;
			$subject =~ s/<<$key>>/$FIELDS{$key}/g;
		}
			
		if($html eq "on") {
			print MAIL "Content-Type: text/html\015\012";
		}
		print MAIL "From: \"$from\" <$FORM{'reply-to'}>\015\012";
		print MAIL "Subject: $subject\015\012";
		print MAIL "To: $FORM{'email'}\015\012"; 

		print MAIL "\015\012";
		
		# For qmail users
		$emessage =~ s/\015\012/\n/gs;
		$emessage =~ s/\015/\n/gs;
		$emessage =~ s/\n/\015\012/gs;
		
		print MAIL "$emessage";

		if($mail_type) {
				
			print MAIL "\015\012.\015\012";
	
			$response = <MAIL>;
			&error("Message not accepted for delivery: $response<BR> Please try again.") if ! $response || $response =~ /^[45]/;
			if ($response =~ /^221/){
				close(MAIL); 
				&error("Server disconnected: $response");
			}
			&smtp_disconnect;
		}
		else {
			close(MAIL);
		}
	}	
    
    if(-e "$base_dir/autoresponders/$FORM{'autoresponder'}.add" && (! $verify_new_users || $FORM{'action'} =~ /^\w{2}\d{7}$/)  && $message ne "" && $FORM{'autoresponder'} ne "all") {
		
		open(RESPOND,"$base_dir/autoresponders/$FORM{'autoresponder'}.add") || &error("$TXT{'2'} $FORM{'autoresponder'}.add");
		@MESSAGE =<RESPOND>;
		close(RESPOND);
		
		chomp($from = shift(@MESSAGE));
		chomp($FORM{'reply-to'} = shift(@MESSAGE));
		chomp($subject = shift(@MESSAGE));
		chomp($html = shift(@MESSAGE));
		$to = $FORM{'email'};
		
		$emessage = join("",@MESSAGE);
    	
    	if($mail_type) {
    		&smtp_connect;
			&smtp_reset;
		}
		else {
			open(MAIL,"|$mailprog -t") || &error("$TXT{'3'} $mailprog");
		}
		
		$join_groups =~ s/\|\|/\&/g;
		$FORM{'email'} = &encode("$FORM{'email'}");
		$FIELDS{'remove link'} = "$script_directory/manager.pl?action=delete&email=$FORM{'email'}&$join_groups";
		
		foreach $field (keys %FIELDS) {
			$emessage =~ s/<<$field>>/$FIELDS{$field}/g;
			$subject =~ s/<<$field>>/$FIELDS{$field}/g;
		}
		
		if($html eq "on") {
			print MAIL "Content-Type: text/html\015\012";
		}
		
		print MAIL "From: \"$from\" <$FORM{'reply-to'}>\015\012";
		print MAIL "Subject: $subject\015\012";
		print MAIL "To: $to\015\012"; 
		print MAIL "\015\012";
		
		# For qmail users
		$emessage =~ s/\015\012/\n/gs;
		$emessage =~ s/\015/\n/gs;
		$emessage =~ s/\n/\015\012/gs;
		
		print MAIL "$emessage";

		# END OF EMAIL MESSAGE
			
		if($mail_type) {
			print MAIL "\015\012.\015\012";
	
			$response = <MAIL>;
			&error("Message not accepted for delivery: $response &lt\;$to&gt\;<BR> Please try again") if ! $response || $response =~ /^[45]/;
			if ($response =~ /^221/){
					close(MAIL);
 					&error("Server disconnected: $response");
			}
    		&smtp_disconnect;
    	}
    	else {
    		close(MAIL);
    	}
    }
    
    if(-e "$base_dir/autoresponders/$FORM{'autoresponder'}.notify" && (! $verify_new_users || $FORM{'action'} =~ /^\w{2}\d{7}$/)  && $message ne "" && $FORM{'autoresponder'} ne "all") {
    	
    	open(RESPOND,"$base_dir/autoresponders/$FORM{'autoresponder'}.notify") || &error("$TXT{'2'} $FORM{'autoresponder'}.notify");
		@MESSAGE =<RESPOND>;
		close(RESPOND);
		
		chomp($from = shift(@MESSAGE));
		chomp($FORM{'reply-to'} = shift(@MESSAGE));
		chomp($subject = shift(@MESSAGE));
		chomp($html = shift(@MESSAGE));
		$to = $admin_email_address;
		
		$emessage = join("",@MESSAGE);
		
    	if($mail_type) {
    		&smtp_connect;
			&smtp_reset;
		}
		else {
			open(MAIL,"|$mailprog -t") || &error("$TXT{'3'} $mailprog");
		}
		
		
		foreach $field (keys %FIELDS) {
			$emessage =~ s/<<$field>>/$FIELDS{$field}/g;
			$subject =~ s/<<$field>>/$FIELDS{$field}/g;
			$from =~ s/<<$field>>/$FIELDS{$field}/g;
			$FORM{'reply-to'} =~ s/<<$field>>/$FIELDS{$field}/g;
		}
		
		if($html eq "on") {
			print MAIL "Content-Type: text/html\015\012";
		}
		
		print MAIL "From: \"$from\" <$FORM{'reply-to'}>\015\012";
		print MAIL "Subject: $subject\015\012";
		print MAIL "To: $to\015\012"; 
		print MAIL "\015\012";
		
		# For qmail users
		$emessage =~ s/\015\012/\n/gs;
		$emessage =~ s/\015/\n/gs;
		$emessage =~ s/\n/\015\012/gs;
		
		print MAIL "$emessage";
			
		# END OF EMAIL MESSAGE
			
		if($mail_type) {
			print MAIL "\015\012.\015\012";
	
			$response = <MAIL>;
			&error("Message not accepted for delivery: $response<BR> Please try again") if ! $response || $response =~ /^[45]/;
			if ($response =~ /^221/){
					close(MAIL);
 					&error("Server disconnected: $response");
			}
    		&smtp_disconnect;
    	}
    	else {
    		close(MAIL);
    	}
    	
    }
    
    if($FORM{'verify_redirect'} =~ /^(http|ftp)/i && $FORM{'action'} =~ /^\w{2}\d{7}$/ && $errors eq "") {
    	print "Location: $FORM{'verify_redirect'}\n\n";
    }
    elsif($FORM{'subscribe_redirect'} && $errors eq "") {
    	print "Location: $FORM{'subscribe_redirect'}\n\n";
    }
    elsif($FORM{'redirect'} && $errors eq "") {
    	print "Location: $FORM{'redirect'}\n\n";
    }
    else {
    	if($FORM{'action'} =~ /^\w{2}\d{7}$/ || ! $verify_new_users) {
    		
    		&header;
    		
			######## EDIT MESSAGE HERE ###########################
    		# Please do not remove the powered by Post Office note
    		# Thank you!  Just edit the text between the two
    		# exclamation marks.  Do not put any exclamation marks
    		# in your message without putting a back slash before it.
    		
			if($message) {
				print qq!
				$TXT{'15'}
				$message<P>
				!;
			}
			if($errors) {
				print qq!$TXT{'16'}
				$errors<P>!;
			}
			
			print qq!
			<BR><BR><BR>
			<CENTER>
			$TXT{'P'}
			</CENTER>
			!;
			
			####### STOP EDITING MESSAGE HERE ######################
			
			&footer;
		}
		else {
			&header;
			
			######## EDIT MESSAGE HERE ###########################
    		# Please do not remove the powered by Post Office note
    		# Thank you!  Just edit the text between the two
    		# exclamation marks.  Do not put any exclamation marks
    		# in your message without putting a back slash before it.
    		
    		if($message) {
				print qq!
				$TXT{'17'}
				$TXT{'18'}
				$message<P>
				!;
			}
			
			if($errors) {
				print qq!$TXT{'16'}
				$errors<P>!;
			}
			
			print qq!
			<BR><BR><BR>
			<CENTER>
			$TXT{'P'}
			</CENTER>
			!;
			
			####### STOP EDITING MESSAGE HERE ######################
			
			&footer;
		}

	}
}


elsif($FORM{'action'} =~ /delete/i || $FORM{'action'} =~ /remove/i) {
	
	&error("$TXT{'5'}") unless $FORM{'email'};
	if(! &checksyntax("$FORM{'email'}")) {
        &error("$TXT{'6'}");
    	}
	
	$x = 0;
	for($i=1;$i<=$max_groups;$i++) {
				
		$field = "group$i";
		
		if($FORM{$field} eq "") {
			next;
		}

		$database = "$base_dir/$FORM{$field}.dat";
    	$r = 0;
    
		&file_lock("$FORM{$field}");
		
    	open(DAT, "$database") || &error("$TXT{'2'} $database\n");
    	open(NEW, ">$base_dir/$FORM{$field}.dat.tmp") || &error("$TXT{'1'} $database.tmp");
    	while($line =<DAT>) {
    		if($line =~ /$FORM{'email'}/i) {
    			$r += 1;
    			$x = 1;
    			$entry = $line;
    		}
    		else {
    			print NEW "$line";
    		}
    	}
    	close(DAT);
    	close(NEW);
    	#unlink("$database") || &error("Could not remove Post Office temperary file");
    	rename("$base_dir/$FORM{$field}.dat.tmp","$database") || &error("$TXT{'1'} $database");

    	if($r) {

    		open(INFO, "$base_dir/$FORM{$field}.info") || &error("$TXT{'2'} $FORM{$field}.info");
    		@MYINFO =<INFO>;
    		close(INFO);
    		
    		chomp($MYINFO[0]);
    		chomp($MYINFO[1]);
    	
    		@fields = split(/\&\&/,$MYINFO[1]);
    		
    		chomp($entry);
    		$c = 0;
			@datafields = split(/\&\&/,$entry);
			foreach $myfield (@fields) {
    			$FIELDS{$myfield} = $datafields[$c];
    			$c++;
    		}
    		
    		$MYINFO[0] -= $r;
    	
    		open(INFO, ">$base_dir/$FORM{$field}.info") || &error("$TXT{'1'} $FORM{$field}.info");
    		print INFO "$MYINFO[0]\n";
    		print INFO "$MYINFO[1]";
    		close(INFO);
    		
    		if($log_opt_out) {
    			if(! -e "$base_dir/$FORM{$field}.out") {
    				open(OPTOUT,">$base_dir/$FORM{$field}.out") || &error("$TXT{'1'} $FORM{$field}.out");
    				print OPTOUT "";
    				close(OPTOUT);
    			}
    			open(OPTOUT,">>$base_dir/$FORM{$field}.out") || &error("$TXT{'1'} $FORM{$field}.out");
    			print OPTOUT "$FIELDS{'email'}\n";
    			close(OPTOUT);
    		}
    		
    		if(-e "$base_dir/autoresponders/$FORM{$field}.remove" && $FORM{'autoresponder'} eq "all") {
    	
				open(RESPOND,"$base_dir/autoresponders/$FORM{$field}.remove") || &error("$TXT{'2'} $FORM{$field}.remove");
				@MESSAGE =<RESPOND>;
				close(RESPOND);
		
				chomp($from = shift(@MESSAGE));
				chomp($FORM{'reply-to'} = shift(@MESSAGE));
				chomp($subject = shift(@MESSAGE));
				chomp($html = shift(@MESSAGE));
				$to = $FORM{'email'};
		
    			if($mail_type) {
    				&smtp_connect;
    				&smtp_reset;
    			}
    			else {
    				open(MAIL,"|$mailprog -t") || &error("$TXT{'3'} $mailprog\n");
    			}

				#-----------------------------------------------------------------#
				#### EMAIL MESSAGE OF THE AUTORESPONDER ###########################
				#-----------------------------------------------------------------#
		
				$emessage = join("",@MESSAGE);

				foreach $field (keys %FIELDS) {
					$emessage =~ s/<<$field>>/$FIELDS{$field}/g;
					$subject =~ s/<<$field>>/$FIELDS{$field}/g;
				}
		
				if($html eq "on") {
					print MAIL "Content-Type: text/html\n";
				}
		
				print MAIL "From: \"$from\" <$FORM{'reply-to'}>\015\012";
				print MAIL "Subject: $subject\015\012";
				print MAIL "To: $to\015\012"; 

				print MAIL "\015\012";
		
				# For qmail users
				$emessage =~ s/\015\012/\n/gs;
				$emessage =~ s/\015/\n/gs;
				$emessage =~ s/\n/\015\012/gs;
		
				print MAIL "$emessage";
			
				# END OF EMAIL MESSAGE
			
				if($mail_type) {
					print MAIL "\015\012.\015\012";
					$response = <MAIL>;
					&error("Message not accepted for delivery: $response<BR>  Please try again.") if ! $response || $response =~ /^[45]/;
					if ($response =~ /^221/){
						close(MAIL);
 						&error("Server disconnected: $response");
					}
    				&smtp_disconnect;
    			}
    			else {
    				close(MAIL);
    			}	
    		}
    		
    	}
    	&file_unlock("$FORM{$field}");
    
	} # End Loop
	
    if(! $FORM{'autoresponder'}) {
    	for($i=1;$i<=$max_groups;$i++) {
    		$field = "group$i";
    		if($FORM{$field} ne "") {
    			$FORM{'autoresponder'} = $FORM{$field};
    			last;
    		}
    	}
    }


    if(-e "$base_dir/autoresponders/$FORM{'autoresponder'}.remove" && $x && $FORM{'autoresponder'} ne "all") {

		open(RESPOND,"$base_dir/autoresponders/$FORM{'autoresponder'}.remove") || &error("$TXT{'2'} $FORM{'autoresponder'}.remove");
		@MESSAGE =<RESPOND>;
		close(RESPOND);
		
		chomp($from = shift(@MESSAGE));
		chomp($FORM{'reply-to'} = shift(@MESSAGE));
		chomp($subject = shift(@MESSAGE));
		chomp($html = shift(@MESSAGE));
		$to = $FORM{'email'};
		
    	if($mail_type) {
    		&smtp_connect;
    		&smtp_reset;
    	}
    	else {
    		open(MAIL,"|$mailprog -t") || &error("$TXT{'3'} $mailprog\n");
    	}

		#-----------------------------------------------------------------#
		#### EMAIL MESSAGE OF THE AUTORESPONDER ###########################
		#-----------------------------------------------------------------#
		
		$emessage = join("",@MESSAGE);

		foreach $field (keys %FIELDS) {
			$emessage =~ s/<<$field>>/$FIELDS{$field}/g;
			$subject =~ s/<<$field>>/$FIELDS{$field}/g;
		}
		
		if($html eq "on") {
			print MAIL "Content-Type: text/html\n";
		}
		
		print MAIL "From: \"$from\" <$FORM{'reply-to'}>\015\012";
		print MAIL "Subject: $subject\015\012";
		print MAIL "To: $to\015\012"; 

		print MAIL "\015\012";
		
		# For qmail users
		$emessage =~ s/\015\012/\n/gs;
		$emessage =~ s/\015/\n/gs;
		$emessage =~ s/\n/\015\012/gs;
		
		print MAIL "$emessage";
			
		# END OF EMAIL MESSAGE
			
		if($mail_type) {
			print MAIL "\015\012.\015\012";
			$response = <MAIL>;
			&error("Message not accepted for delivery: $response<BR>  Please try again.") if ! $response || $response =~ /^[45]/;
			if ($response =~ /^221/){
					close(MAIL);
 					&error("Server disconnected: $response");
			}
    		&smtp_disconnect;
    	}
    	else {
    		close(MAIL);
    	}
    }
    	
    if($FORM{'unsubscribe_redirect'} && $x) {
    	print "Location: $FORM{'unsubscribe_redirect'}\n\n";
    }
    elsif($FORM{'redirect'} && $x) {
    	print "Location: $FORM{'redirect'}\n\n";
    }
    elsif($x) {
    	
    	&header;
    	
    	######## EDIT MESSAGE HERE ###########################
    	# Please do not remove the powered by Post Office note
    	# Thank you!  Just edit the text between the two
    	# exclamation marks.  Do not put any exclamation marks
    	# in your message without putting a back slash before it.
    		
		print qq!
		$TXT{'19'}
		<BR><BR><BR>
		<CENTER>
		$TXT{'P'}
		</CENTER>
		!;
		
		####### STOP EDITING MESSAGE HERE ######################
		
		
		&footer;
    }
    else {
    	
    	&header;

		######## EDIT MESSAGE HERE ###########################
   		# Please do not remove the powered by Post Office note
   		# Thank you!  Just edit the text between the two
   		# exclamation marks.  Do not put any exclamation marks
   		# in your message without putting a back slash before it.

		print qq!
		$TXT{'20'}
		<BR><BR><BR>
		<CENTER>
		$TXT{'P'}
		</CENTER>
		!;
		
		####### STOP EDITING MESSAGE HERE ######################
		
		&footer;
    }
    
}
else {
	&error("$TXT{'4'}");	
}